package guida_turistica_senza_interfacce;

import java.util.*;

public class GuidaTuristica {
	
	private static final double MAX_VOTO = 5.0;
	
	private List<Via> vie;
	private Map<PuntoGeo,PuntoDiInteresse> localizzazione;
	private Map<PuntoDiInteresse,Double> votiPI;
	
	public GuidaTuristica(){
		this(new ArrayList<Via>(),new HashMap<PuntoGeo,PuntoDiInteresse>(),new HashMap<PuntoDiInteresse,Double>());
	}
	
	public GuidaTuristica(List<Via> v, Map<PuntoGeo,PuntoDiInteresse> loc, Map<PuntoDiInteresse,Double> voti){
		vie = v;
		localizzazione = loc;
		votiPI = voti;
	}
	
	// punto 3)
	public Set<PuntoDiInteresse> cercaPuntiDiInteresse(PuntoGeo p, double r, String citta, String nomeVia){
		Set<PuntoDiInteresse> setPunti = new HashSet<PuntoDiInteresse>();
		Set<PuntoGeo> puntiInVia = null; 
		boolean trovata = false;
		for(int i=0; i<vie.size() && !trovata; i++)
			if(vie.get(i).getNome().equals(nomeVia) && vie.get(i).getCitta().equals(citta)){
				trovata = true;
				puntiInVia = vie.get(i).puntiEntroRaggio(p, r);
			}
		if(puntiInVia != null){
			Iterator<PuntoGeo> i = puntiInVia.iterator();
			while(i.hasNext())
				setPunti.add(localizzazione.get(i.next()));
		}
		return setPunti;
	}
	
	// punto 4) 
	public List<PuntoDiInteresse> topPuntiDiInteresse(){
		List<PuntoDiInteresse> listaPunti = new ArrayList<PuntoDiInteresse>();
		Iterator<PuntoDiInteresse> i = votiPI.keySet().iterator();
		while(i.hasNext()){
			PuntoDiInteresse p = i.next();
			if(votiPI.get(p) == MAX_VOTO)
				listaPunti.add(p);
		}
		return listaPunti;
	}
	

}
