package guida_turistica_senza_interfacce;

import java.util.*;

public class Via{
	
	private static final int MAX_PUNTI = 100;
	
	private String nome;
	private String citta;
	private PuntoGeo[] punti;
	private int numPunti;
	
	public Via(){
		this("","",new PuntoGeo[MAX_PUNTI],0);
	}
	
	public Via(String n, String c, PuntoGeo[] p, int num){
		nome = n;
		citta = c;
		punti = p;
		numPunti = num;
	}
	
	// punto 2)
	public Set<PuntoGeo> puntiEntroRaggio(PuntoGeo p, double r){
		Set<PuntoGeo> puntiInRaggio = new HashSet<PuntoGeo>();
		for(int i=0; i<numPunti; i++)
			if(punti[i].entroRaggio(p,r))
				puntiInRaggio.add(punti[i]);
		return puntiInRaggio;
	}
	
	public String getNome(){
		return nome;
	}
	
	public String getCitta(){
		return citta;
	}
	
}
